import numpy as np
import Nio, Ngl

# Read data
filename = "../Data/ruc.grb"
a   = Nio.open_file(filename)
u   = a.variables["U_GRD_236_MWSL"][:]
v   = a.variables["V_GRD_236_MWSL"][:]
lat = a.variables["gridlat_236"][:]
lon = a.variables["gridlon_236"][:]


wks = Ngl.open_wks("x11","grib1_plot_uv")

# Set some plot options
res = Ngl.Resources()

# Vector options
res.vcGlyphStyle          = "CurlyVector"
res.vcLineArrowThicknessF = 2.0           # default is 1
res.vcRefLengthF          = 0.03
res.vcMinDistanceF        = 0.01
res.vcRefMagnitudeF       = 40
res.vcMonoLineArrowColor  = False
res.vcLevelPalette        = "StepSeq25"

# Map options
res.mpLimitMode       = "LatLon"
res.mpMinLatF         = lat.min()-1
res.mpMaxLatF         = lat.max()+1
res.mpMinLonF         = lon.min()-1
res.mpMaxLonF         = lon.max()+1
res.mpDataBaseVersion = "MediumRes"

# Main Title
res.tiMainString      = filename

# Labelbar
res.lbOrientation     = "Horizontal"

# Additional resources needed for putting contours on map
res.vfXArray          = lon  # [::2,::2]
res.vfYArray          = lat  # [::2,::2]

plot = Ngl.vector_map(wks,u,v,res)

Ngl.end()

