# This one a pain because of multiple shapefiles used.
import numpy as np
import Nio, Ngl, os

#---Read data
filename = "../Data/MET9_IR108_cosmode_0909210000.grb2"
a    = Nio.open_file(filename)
sbt  = a.variables["SBTMP_P31_GRLL0"][:]
lat  = a.variables["gridlat_0"]
lon  = a.variables["gridlon_0"]
nlat = lat.shape[0]
nlon = lat.shape[1]

wks = Ngl.open_wks("x11","grib2_plot_rotated_shapefiles")

#---Set some plot options
res                   = Ngl.Resources()
res.nglDraw            = False     # Turn off draw and frame. Will do
res.nglFrame           = False     # this after we add shapefile outlines.

# Contour options
res.cnFillOn           = True          # turn on contour fill
res.cnLinesOn          = False         # turn off contour lines
res.cnLineLabelsOn     = False         # turn off line labels
res.cnFillPalette      = "BlGrYeOrReVi200"
res.lbLabelFontHeightF = 0.015              # default is a bit large

# Map options for a native projection
res.mpLimitMode        = "Corners"
res.mpLeftCornerLatF   = lat[nlat-1][0] 
res.mpLeftCornerLonF   = lon[nlat-1][0]
res.mpRightCornerLatF  = lat[0][nlon-1]      
res.mpRightCornerLonF  = lon[0][nlon-1] 
res.mpCenterLonF       = lon.Longitude_of_southern_pole 
res.mpCenterLatF       = lon.Latitude_of_southern_pole + 90

res.trYReverse         = True
res.tfDoNDCOverlay     = True

# Other map options
res.mpGridAndLimbOn       = False
res.mpDataBaseVersion     = "MediumRes"
res.mpDataSetName         = "Earth..2"
res.mpOutlineBoundarySets = "AllBoundaries"
res.mpOutlineOn           = False

# Main Title
res.tiMainString      = filename

plot = Ngl.contour_map(wks,sbt,res)

# Attach shapefile outlines to plot object.
shp_pfxs = ["SWE","FRA", "ITA", "DEU","POL","BEL","TUR"]

plres                  = Ngl.Resources()      # resources for polylines
plres.gsLineColor      = "navyblue"
plres.gsLineThicknessF = 2.0                  # default is 1.0

lnid = []
for s in shp_pfxs:
  shp_filename = "%s_adm/%s_adm0.shp" % (s,s)
  if not os.path.exists(shp_filename):
    print "You need to download %s shapefiles from gadm.org/country" % shp_filename
    print "Skipping.."
    continue

  f   = Nio.open_file(shp_filename)
  lon = np.ravel(f.variables["x"][:])
  lat = np.ravel(f.variables["y"][:])
  plres.gsSegments = f.variables["segments"][:,0]
  lnid.append(Ngl.add_polyline(wks, plot, lon, lat, plres))

Ngl.draw(plot)
Ngl.frame(wks)

Ngl.end()

