import Nio,Ngl
import sys
import numpy as np

print "Warning, this script takes several minutes..."

dir      = "../Data/"
filename = "3B-MO.MS.MRG.3IMERG.20140701-S000000-E235959.07.V03D.HDF5"
opt = Nio.options()
opt.FileStructure = 'advanced'
f = Nio.open_file(dir + filename, "r", options=opt)
g = f.groups['Grid']

precip = g.variables['precipitation']
lat    = g.variables['lat'][:]
lon    = g.variables['lon'][:]
yyyymmdd = filename.split(".")[4].split('-')[0]
print precip[:].min()
print precip[:].max()

wres = Ngl.Resources()
wres.wkWidth = 1500
wres.wkHeight = 1500
wks = Ngl.open_wks("png","hdf5_gpm",wres)

res                      = Ngl.Resources()
res.cnFillOn             = True               # turn on contour fill
res.cnLinesOn            = False              # turn off contour lines
res.cnLineLabelsOn       = False              # turn off line labels

res.cnFillMode           = "RasterFill"       # These two resources
res.trGridType           = "TriangularMesh"   # can speed up plotting.

res.cnLevelSelectionMode = "ExplicitLevels"
res.cnLevels             = [0.01,0.02,0.04,0.08,0.16,0.32,0.64, 0.96]
res.cnFillColors         = ["white","cyan", "green","yellow",
                            "darkorange","red","magenta","purple","black"]

# make Dateline the center of the plot (default is GM)
res.mpCenterLonF         = 180  

res.tiMainString         = "precipitation (%s) (%s)" % (precip.units,yyyymmdd)
res.lbLabelFontHeightF   = 0.01              # default is a bit large
res.lbOrientation        = "horizontal"

res.sfMissingValueV      = precip._FillValue
res.sfXArray             = lon
res.sfYArray             = lat

print precip.shape
print lat.shape
print lon.shape

plot = Ngl.contour_map(wks,precip[:].transpose(),res)

Ngl.end()




