import numpy as np
import Nio

print "=================================================="
print "Reading variable from WRF output file"
filename = "../Data/wrfout_d03_2012-04-22_23_00_00_var_partial" + ".nc"
a = Nio.open_file(filename)

T2 = a.variables["T2"]    # NioVariable object, has metadata
print "type(T2)    ",type(T2)
print "type(T2[:]) ",type(T2[:])     # NumPy array
print "min/max T2  ",T2[:].min(),T2[:].max()
print "average     ",np.average(T2[:])
#print np.average(T2)                # don't do this!!

print "--------------------------------------------------"
print "Is T2[:] a MaskedArray?",isinstance(T2[:], np.ma.MaskedArray)
print "Is T2[:] a NumPy Array?",isinstance(T2[:], np.ndarray)

print "=================================================="
print "Reading variable from CESM CAM5 file"
filename = "../Data/ts_Amon_CESM1-CAM5_historical_r1i1p1_185001-200512_partial.nc"
a = Nio.open_file(filename)
ts = a.variables["ts"]

print "type(ts)    ",type(ts)
print "type(ts[:]) ",type(ts[:])     # NumPy array
print "min/max ts  ",ts[:].min(),ts[:].max()
print "average     ",np.average(ts[:])
print "--------------------------------------------------"
print "Is ts[:] a MaskedArray?",isinstance(ts[:], np.ma.MaskedArray)
print "Is ts[:] a NumPy Array?",isinstance(ts[:], np.ndarray)
print "--------------------------------------------------"


print "=================================================="
print "Reading variable from CESM CAM5 file"
filename = "../Data/MOD06_L2.A2010031.1430.005.2010031221343.hdf"
f        = Nio.open_file(filename)
ctt      = f.variables["Cloud_Top_Temperature"]

print "type(ctt)      ",type(ctt)
print "type(ctt[:])   ",type(ctt[:])     # NumPy array
print "min/max ctt    ",ctt[:].min(),ctt[:].max()
print "average (np)   ",np.average(ctt[:])
print "average (np.ma)",np.ma.average(ctt[:])
print "--------------------------------------------------"
print "Is ctt[:] a MaskedArray?",isinstance(ctt[:], np.ma.MaskedArray)
print "Is ctt[:] a NumPy Array?",isinstance(ctt[:], np.ndarray)
print "--------------------------------------------------"
