import numpy, Nio, Ngl

def plot_ts_Amon_ngl(t,lat,lon,res=None):
  """
Creates a color contour plot over a map of the given variable, given
its lat/lon arrays.

plot_ts_Amon_ngl(t,lat,lon)

t       - The variable to plot
lat,lon - The lat/lon arrays
  """

#---Open file or window for graphics
  png_name = "plot_ts_Amon"
  wres = Ngl.Resources()
  wres.wkWidth  = 500
  wres.wkHeight = 500
  wks = Ngl.open_wks("png",png_name,wres)

#---Set some plot options
  if res is None:
    res = Ngl.Resources()

# Contour options
  res.cnFillOn          = True          # turn on contour fill
  res.cnLinesOn         = False         # turn off contour lines
  res.cnLineLabelsOn    = False         # turn off line labels
  res.cnFillPalette     = Ngl.read_colormap_file("MPL_RdYlBu")[::-1,:]
# Map options
  res.mpCenterLonF      = 180           # default is lon=0

# Labelbar options
  res.lbOrientation     = "horizontal"  # default is "vertical"

# Main Title
  res.tiMainString = getattr(res,"tiMainString","%s (%s)" % (t.long_name,t.units))
  res.tiMainFontHeightF = 0.02         # default is a big large

#---Additional resources needed for putting contours on map
  res.sfXArray          = lon
  res.sfYArray          = lat

#---Plot first time step
  plot = Ngl.contour_map(wks,t[0,:,:],res)
  print("Created %s.png" % png_name)

filename = "../Data/ts_Amon_CESM1-CAM5_historical_r1i1p1_185001-200512_partial.nc"
a   = Nio.open_file(filename)
ts  = a.variables["ts"]           # Get the "ts" variable object
lat = a.variables["lat"][:]       # 1D array (size nlat)
lon = a.variables["lon"][:]       # 1D array (size nlon)

plot_ts_Amon_ngl(ts,lat,lon)   

