# # Using PyNIO to examine NetCDF, GRIB, and HDF-EOS files
import Nio as nio


# ### NetCDF file with a rectilinear grid

filename="../Data/ts_Amon_CESM1-CAM5_historical_r1i1p1_185001-200512.nc"
f = nio.open_file(filename)
print(f)


# ### WRF ouput file (NetCDF) with a curvilinear grid
# 
# The WRF file doesn't have a ".nc" suffix; watch what happens if you forget to add it.

# This code will produce an error about an invalid extension
#filename="Data/wrfout_d03_2012-04-22_23_00_00"
#f = nio.open_file(filename)
#print(f)


# ### Add the ".nc" to the WRF filename

filename="../Data/wrfout_d03_2012-04-22_23_00_00.nc"
f = nio.open_file(filename)
print(f)


# ### GRIB1 file - curvilinear grid

filename="../Data/ruc.grb"
f = nio.open_file(filename)
print(f)

# ### GRIB2 file - curvilinear grid

filename="../Data/MET9_IR108_cosmode_0909210000.grb2"
f = nio.open_file(filename)
print(f)


# ### HDF-EOS file with an ".hdf" suffix
# Note the top part of the "global attributes" output.

filename="../Data/MOD06_L2.A2010031.1430.005.2010031221343.hdf"
f = nio.open_file(filename)
print(f)


# ### Add ".he2" suffix and open file again

filename = filename + ".he2"
f = nio.open_file(filename)
print(f)


# ### Exercise: Write short python script to output contents of any supported file, by passing the filename via a command line argument
# 
# For example:
# 
# python niodump.py -f MOD06_L2.A2010031.1430.005.2010031221343.hdf
