import numpy, Nio, Ngl, os,sys

filename = "../Data/wrfout_d03_2012-04-22_23_00_00_var_partial.nc"
f  = Nio.open_file(filename,"w")          # Open WRF output file
T  = f.variables["T"]                     # Read some variables
P  = f.variables["P"]
PB = f.variables["PB"]

TK  = T[:] + 300
PPB = P[:] + PB[:]
TC  = Ngl.wrf_tk(PPB, TK) - 273.16         # Convert to degC
print "TC after calculation: %g / %g" % (numpy.min(TC[:]),numpy.max(TC[:]))

# Define new variable on file
new_vname = "TC"
f.create_variable(new_vname,'d',T.dimensions)

# Write attributes of variable to file, changing two of them.
varAtts = T.__dict__.keys()
varAtts.sort()
for att in varAtts:
  if att == "description":
    value = "Temperature"
  elif att == "units":
    value = "degC"
  else:
    value = getattr(T,att)
  setattr(f.variables[new_vname],att,value)

f.variables[new_vname].assign_value(TC)      # Write data

f.close()

# Reopen the file and read values back in
f = Nio.open_file(filename,"r")
print(f)

tc = f.variables["TC"]
print "TC after reading back in: %g / %g" % (numpy.min(tc[:]),numpy.max(tc[:]))
