import numpy, Nio, Ngl
from wrf_plot_ngl import *

#---Read data
filename = "../Data/wrfout_d03_2012-04-22_23_00_00_var_partial.nc"
a  = Nio.open_file(filename)
T2 = a.variables["T2"]

res                 = Ngl.Resources()
res.cnLevelSpacingF = 2.0                # PyNGL chose 4.0
res.cnFillPalette   = "WhViBlGrYeOrReWh" # change color map

# Contour options
wrf_plot_from_file(filename,"T2",res=res,contour_type="raster",
                   output_name="wrfplot_T2_1")

# Subset the color map and plot again
res.cnFillPalette = Ngl.read_colormap_file("WhViBlGrYeOrReWh")[10:84,:]
wrf_plot_from_file(filename,"T2",res=res,contour_type="raster",
                   output_name="wrfplot_T2_2")

Ngl.end()

