import numpy as np
import Nio, Ngl

#---Read data
filename = "../Data/wrfout_d03_2012-04-22_23_00_00_var_partial.nc"
a  = Nio.open_file(filename)
T  = a.variables["T"][0,0,:,:]   # Read first time step and level (nlat x nlon)
P  = a.variables["P"][0,0,:,:]
PB = a.variables["PB"][0,0,:,:]

T  = T + 300
P  = P + PB
TC = Ngl.wrf_tk(P, T) - 273.16      # Convert to degC
print("Min/Max TC =",np.min(TC),"/",np.max(TC))

wks = Ngl.open_wks("x11","wrf_plot_TC_ngl")

res                   = Ngl.Resources()

# Contour options
res.cnFillOn           = True               # turn on contour fill
res.cnLinesOn          = False              # turn off contour lines
res.cnLineLabelsOn     = False              # turn off line labels
res.cnFillMode         = "RasterFill"       # These two resources
res.trGridType         = "TriangularMesh"   # can speed up plotting.
res.cnFillPalette      = "ncl_default"      # change color map
res.lbLabelFontHeightF = 0.015              # default is a bit large
res.tiMainString       = "WRF data on native map projection"

# Add WRF native projection map options
Ngl.wrf_map_resources(filename,res)

plot = Ngl.contour_map(wks,TC,res)

Ngl.end()

